# Description:
#   Enable again the 'mattermost-attachment' event
#
# Environment:
#   MATTERMOST_INCOME_URL

slack = require 'hubot-slack'

module.exports = (robot) ->
  options =
    webhook: process.env.MATTERMOST_INCOME_URL

  return robot.logger.error "Missing configuration MATTERMOST_INCOME_URL" unless options.webhook?

  getChannel = (msg) ->
    if msg.room.match /^[#@]/
      # the channel already has an appropriate prefix
      msg.room
    else if msg.user && msg.room == msg.user.name
      "@#{msg.room}"
    else
      "##{msg.room}"

  getUsername = (data) ->
    data.username || robot.name

  attachment = (data) ->
    payload = data.content

    payload.channel  = data.channel || getChannel data.message
    payload.username = getUsername data

    if data.icon_url?
      payload.icon_url = data.icon_url
    else if data.icon_emoji?
      payload.icon_emoji = data.icon_emoji
    else if payload.username == robot.name
     

    reqbody = JSON.stringify(payload)

    robot.http(options.webhook)
      .header("Content-Type", "application/json")
      .post(reqbody) (err, res, body) ->
        return if res.statusCode == 200

        robot.logger.error "Error!", res.statusCode, body

  robot.on "mattermost-attachment", (data) ->
    robot.logger.warning "Using deprecated event 'mattermost-attachment'"
    attachment data

  robot.on "mattermost.attachment", (data) ->
    attachment data
